from generate import *
import ast
import code
from compiler.ast import Node
import commands
import os
import sys
from PySide import QtGui, QtCore
from PySide import *
from PyQt4.QtGui import *
import unicodedata
pattern = ""
filen = ""
args = {}
filename = ""
listoflist = [[],[]]
listClass = []
listFuncs = []
class GuiInput(QtGui.QWidget):	
	def __init__(self):
		super(GuiInput, self).__init__()		
		self.initUI()	
	def initUI(self):	  
		self.setWindowTitle("Choose Your Pattern")
		self.lbl = QtGui.QLabel("Select A Pattern", self)
		self.lbl.setObjectName("lbl")
		combo = QtGui.QComboBox(self)
		combo.addItem("Class Decorator")
		combo.addItem("Adapter")
		combo.addItem("Factory")
		combo.addItem("Observer")
		combo.setObjectName("combo")
		submit = QtGui.QPushButton("NEXT",self)
		submit.clicked.connect(self.SubPattern)
		self.combo = combo
		self.grid = QtGui.QGridLayout()
		self.grid.setVerticalSpacing(10)
		self.grid.addWidget(self.lbl, 1, 0,1,1)
		self.grid.addWidget(combo, 1, 1,1,1)
		self.grid.addWidget(submit,1,2,1,1)
		self.setLayout(self.grid)
		self.grid.setObjectName("grid")
		self.setGeometry(200, 200, 790, 100)
		self.setWindowTitle('Choose Your Pattern')	
		self.show()
	def SubPattern(self):
	
		self.pattern = self.combo.currentText()
		print self.pattern
		clear(self.grid)
		self.InitScreen2()
		self.setWindowTitle(self.pattern)
	def InitScreen2(self):
		self.setWindowTitle(self.pattern)
		self.fbtn = QtGui.QPushButton('Select a File', self)
		self.fbtn.clicked.connect(self.showDialog)
		self.fbtn.resize(self.fbtn.sizeHint())
		self.fbtn.setObjectName("FBTN")

		self.filelbl = QtGui.QLabel("Choose the file that you would like this {} to be generated for".format(self.pattern), self)
		self.filename = QtGui.QLabel("No File Selected, Choose a File by clicking the select a file button", self)
		self.filelbl.setObjectName("filelbl")
		self.grid.addWidget(self.filelbl,1,0,1,1)
		self.grid.addWidget(self.fbtn,1,1,1,1)
		self.grid.addWidget(self.filename,2,0,1,19)
		self.spacer = QtGui.QLabel("", self)
		self.grid.addWidget(self.spacer,20,20,1,1)
	def onActivated(self, text):
		global filename
		global pattern
		global listClass
		listClass = []
		global listFuncs
		listFuncs = []
		pattern = text
		widgets = []
		pattern = self.pattern
		label2 = None;
		if pattern == "Method Decorator":
			num = 1
			CLS = False
			label1 = QtGui.QLabel("Select A Function to Decorate", self)
			label2 = QtGui.QLabel("Decorator with arguements?", self)
		if pattern == "Adapter" or pattern == "Observer":
			num = 2
			CLS = True
			label1 = QtGui.QLabel("Select An Adaptee", self) if pattern == "Adapter" else QtGui.QLabel("Select An Observable", self)
			print "ad" if pattern == "Adapter" else "not adapt"
			label2 = QtGui.QLabel("Select A Target", self) if pattern == "Adapter" else QtGui.QLabel("Select An Observer", self)
		if pattern == "Factory" or pattern == "Class Decorator":
			num = 1
			CLS = True
			label1 = QtGui.QLabel("Select the class to use", self)
		print "post pattern choice " + pattern
		self.grid.addWidget(label1,1,0)
		if label2 is not None:
			self.grid.addWidget(label2,2,0)
		with open(filename) as f:
			code = f.read()
		tree = ast.parse(code)
		visitLister().visit(tree)
		args[pattern] = ["",""]
		for x in range(0,num):
			args[pattern][x] = listClass[0] if CLS else listFuncs[0]
		for x in range(0,num):
			temp = QtGui.QComboBox(self)
			widgets.append(temp)
			if CLS == True:
				for i in listClass:
					temp.addItem(i)
			if CLS == False:
				for i in listFuncs:
					temp.addItem(i)
		if pattern == "Method Decorator":
			ArG = ["with arguements","with out arguements"]
			temp = QtGui.QComboBox(self)
			widgets.append(temp)
			args[pattern][1] = ArG[0] 
			for i in ArG:
				temp.addItem(i)
		wnums = [self.onSelectArg1,self.onSelectArg2,self.onSelectArg3]
		i = 0
		for w in widgets:
			w.activated[str].connect(wnums[i])
			self.grid.addWidget(w,1+i,1,1,1)
			i +=1;
	def onSelectArg1(self,text):
		global args
		global pattern
		unicodedata.normalize('NFKD', text).encode('ascii','ignore')
		args[pattern][0] = text
	def onSelectArg2(self,text):
		global pattern
		unicodedata.normalize('NFKD', text).encode('ascii','ignore')
		args[pattern][1] = text
	def onSelectArg3(self,text):
		global pattern
		unicodedata.normalize('NFKD', text).encode('ascii','ignore')
		args[pattern][2] = text	
	def showDialog(self):
		fname, _ = QtGui.QFileDialog.getOpenFileName(self, 'Open file','./')
		f = open(fname, 'r')
		global filename
		filename = fname;
		self.file = fname
		self.setWindowTitle(self.pattern + " IN " + self.file)
		self.filename.setText(fname)
		self.submit = QtGui.QPushButton("NEXT",self)
		self.submit.clicked.connect(self.SubFile)
		self.grid.addWidget(self.submit,3,0,1,3)
	def SubFile(self):
		clear(self.grid)
		self.onActivated(self.pattern)
		self.submit = QtGui.QPushButton("SUBMIT",self)
		self.submit.clicked.connect(self.sendAll)
		self.grid.addWidget(self.submit,3,0,1,3)
	def sendAll(self):
		global args
		global filename
		clear(self.grid)
		pArg = self.pattern
		arguments = args[pArg]
		print "{} call with argemnets {}".format(pArg, arguments)
		print "with filename {}".format(filename)
		result = ""
		if pArg == "Adapter":
			result = genADAPT(filename,arguments[0],arguments[1])
		if pArg == "Method Decorator":
			result = genDec(filename,arguments[0],"arg" if arguments[1] == "with arguments" else 'Generic')
		if pArg == "Observer":
			result = genOBSERV(filename,arguments[0],arguments[1])
		if pArg == "Factory":
			result = genFact(filename,arguments[0])
		if pArg == "Class Decorator":
			result = genClassDec(filename,arguments[0])
		self.final = QtGui.QLabel(result, self)
		qtbn = QtGui.QPushButton("CLOSE GUI",self)
		qtbn.clicked.connect(QtCore.QCoreApplication.instance().quit)
		self.grid.addWidget(self.final,1,0,3,3)
		self.grid.addWidget(qtbn,4,0,1,1)
class visitLister(ast.NodeVisitor):
	def visit_ClassDef(self,node):
		global listClass
		listClass.append(node.name)
	def visit_FunctionDef(self,node):
		global listFuncs
		listFuncs.append(node.name)
def clear(grid):
	layout = []
	for c in range(0,grid.columnCount()):
		for r in range(0,grid.rowCount()):
			item = grid.itemAtPosition(r, c)
			layout.append(item) if item is not None else "chad"
	for widget in layout:
		try:
			widget.widget().deleteLater()
		except Exception, e:
			"--"
		else:
			grid.removeItem(widget)
def main():	
	app = QtGui.QApplication(sys.argv)
	ex = GuiInput()
	sys.exit(app.exec_())
if __name__ == '__main__':
	main()
